aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMingli Yu <Mingli.Yu@windriver.com>2017-12-22 10:54:51 +0800
committerArmin Kuster <akuster808@gmail.com>2017-12-27 07:25:03 -0800
commit5f6fcfd36272768a3ff9078c07c572cf5dc01ccd (patch)
tree25022af3a188e2f53cb4ee65fee02bf543946c9d
parent13c84c645b6126f0cb3d768e8934992f594a82ab (diff)
downloadmeta-openembedded-5f6fcfd36272768a3ff9078c07c572cf5dc01ccd.zip
meta-openembedded-5f6fcfd36272768a3ff9078c07c572cf5dc01ccd.tar.gz
meta-openembedded-5f6fcfd36272768a3ff9078c07c572cf5dc01ccd.tar.bz2
protobuf: add ptest support
* Add DEPENDS_class-target = "protobuf-native" to fix below error: | DEBUG: SITE files ['endian-little', 'common-linux', 'common-glibc', 'bit-64', 'x86_64-linux', 'common'] | DEBUG: Executing shell function do_compile_ptest_base | NOTE: make -C $Prj/build/tmp-glibc/work/core2-64-wrs-linux/protobuf/3.4.1+gitAUTOINC+b04e5cba35-r0/git/examples cpp | make: Entering directory '$Prj/build/tmp-glibc/work/core2-64-wrs-linux/protobuf/3.4.1+gitAUTOINC+b04e5cba35-r0/git/examples' | protoc --cpp_out=. --java_out=. --python_out=. addressbook.proto | make: protoc: Command not found | make: *** [Makefile:25: protoc_middleman] Error 127 * Add run-ptest * Add rdepends on bash and python-protobuf for ptest Signed-off-by: Mingli Yu <Mingli.Yu@windriver.com> Signed-off-by: Armin Kuster <akuster808@gmail.com>
-rw-r--r--meta-oe/recipes-devtools/protobuf/protobuf/run-ptest38
-rw-r--r--meta-oe/recipes-devtools/protobuf/protobuf_3.4.1.bb54
2 files changed, 90 insertions, 2 deletions
diff --git a/meta-oe/recipes-devtools/protobuf/protobuf/run-ptest b/meta-oe/recipes-devtools/protobuf/protobuf/run-ptest
new file mode 100644
index 0000000..7c3a8d1
--- /dev/null
+++ b/meta-oe/recipes-devtools/protobuf/protobuf/run-ptest
@@ -0,0 +1,38 @@
+#!/bin/bash
+DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
+TEST_FILE="/tmp/test.data"
+
+RETVAL=0
+# Test every writing test application
+for write_exe_full_path in ${DIR}/add_person_*; do
+ if [ -x "${write_exe_full_path}" ]; then
+ write_exe=`basename ${write_exe_full_path}`
+ echo "Generating new test file using ${write_exe}..."
+ ${write_exe_full_path} "${TEST_FILE}"
+ RETVAL=$?
+ [ $RETVAL -eq 0 ] || exit $RETVAL
+
+ # Test every reading test application
+ for read_exe_full_path in ${DIR}/list_people_*; do
+ read_exe=`basename ${read_exe_full_path}`
+ echo "Test: Write with ${write_exe}; Read with ${read_exe}..."
+ if [ -x "${read_exe_full_path}" ]; then
+ ${read_exe_full_path} "${TEST_FILE}"
+ RETVAL=$?
+ [ $RETVAL -eq 0 ] || exit $RETVAL
+ fi
+ done
+
+ # Cleanup...
+ if [ -e "${TEST_FILE}" ]; then
+ rm "${TEST_FILE}"
+ fi
+ fi
+done
+
+if [ $RETVAL -eq 0 ] ; then
+ echo "PASS: protobuf"
+else
+ echo "FAIL: protobuf"
+fi
+
diff --git a/meta-oe/recipes-devtools/protobuf/protobuf_3.4.1.bb b/meta-oe/recipes-devtools/protobuf/protobuf_3.4.1.bb
index fae7c18..1407d08 100644
--- a/meta-oe/recipes-devtools/protobuf/protobuf_3.4.1.bb
+++ b/meta-oe/recipes-devtools/protobuf/protobuf_3.4.1.bb
@@ -9,8 +9,10 @@ LICENSE = "BSD-3-Clause"
PACKAGE_BEFORE_PN = "${PN}-compiler ${PN}-lite"
DEPENDS = "zlib"
+DEPENDS_append_class-target = " protobuf-native"
RDEPENDS_${PN}-compiler = "${PN}"
RDEPENDS_${PN}-dev += "${PN}-compiler"
+RDEPENDS_${PN}-ptest = "bash python-protobuf"
LIC_FILES_CHKSUM = "file://LICENSE;md5=35953c752efc9299b184f91bef540095"
@@ -18,13 +20,61 @@ SRCREV = "b04e5cba356212e4e8c66c61bbe0c3a20537c5b9"
PV = "3.4.1+git${SRCPV}"
-SRC_URI = "git://github.com/google/protobuf.git;branch=3.4.x"
+SRC_URI = "git://github.com/google/protobuf.git;branch=3.4.x \
+ file://run-ptest \
+ "
EXTRA_OECONF += " --with-protoc=echo"
-inherit autotools-brokensep
+inherit autotools-brokensep pkgconfig ptest
S = "${WORKDIR}/git"
+TEST_SRC_DIR="examples"
+LANG_SUPPORT="cpp python"
+
+do_compile_ptest() {
+ # Modify makefile to use the cross-compiler
+ sed -e "s|c++|${CXX} \$(LDFLAGS)|g" -i "${S}/${TEST_SRC_DIR}/Makefile"
+
+ mkdir -p "${B}/${TEST_SRC_DIR}"
+
+ # Add the location of the cross-compiled header and library files
+ # which haven't been installed yet.
+ cp "${B}/protobuf.pc" "${B}/${TEST_SRC_DIR}/protobuf.pc"
+ sed -e 's|libdir=|libdir=${PKG_CONFIG_SYSROOT_DIR}|' -i "${B}/${TEST_SRC_DIR}/protobuf.pc"
+ sed -e 's|Cflags:|Cflags: -I${S}/src|' -i "${B}/${TEST_SRC_DIR}/protobuf.pc"
+ sed -e 's|Libs:|Libs: -L${B}/src/.libs|' -i "${B}/${TEST_SRC_DIR}/protobuf.pc"
+ export PKG_CONFIG_PATH="${B}/${TEST_SRC_DIR}"
+
+ # Save the pkgcfg sysroot variable, and update it to nothing so
+ # that it doesn't append the sysroot to the beginning of paths.
+ # The header and library files aren't installed to the target
+ # system yet. So the absolute paths were specified above.
+ save_pkg_config_sysroot_dir=$PKG_CONFIG_SYSROOT_DIR
+ export PKG_CONFIG_SYSROOT_DIR=
+
+ # Compile the tests
+ for lang in ${LANG_SUPPORT}; do
+ oe_runmake -C "${S}/${TEST_SRC_DIR}" ${lang}
+ done
+
+ # Restore the pkgconfig sysroot variable
+ export PKG_CONFIG_SYSROOT_DIR=$save_pkg_config_sysroot_dir
+}
+
+do_install_ptest() {
+ local olddir=`pwd`
+
+ cd "${S}/${TEST_SRC_DIR}"
+ install -d "${D}/${PTEST_PATH}"
+ for i in add_person* list_people*; do
+ if [ -x "$i" ]; then
+ install "$i" "${D}/${PTEST_PATH}"
+ fi
+ done
+ cp "${S}/${TEST_SRC_DIR}/addressbook_pb2.py" "${D}/${PTEST_PATH}"
+ cd "$olddir"
+}
FILES_${PN}-compiler = "${bindir} ${libdir}/libprotoc${SOLIBS}"
FILES_${PN}-lite = "${bindir} ${libdir}/libprotobuf-lite${SOLIBS}"